package com.iot.modbus_rtcp.netty;

import java.util.concurrent.ConcurrentHashMap;

public class DataCache {
    private static ConcurrentHashMap<String, byte[]> mDataCacheMap = new ConcurrentHashMap<>();

    public static void put(String identity, byte[] data) {
        synchronized (DataCache.class) {
            mDataCacheMap.put(identity, data);
        }
    }

    public static byte[] get(String identity) {
        synchronized (DataCache.class) {
            return mDataCacheMap.get(identity);
        }
    }

    public static byte[] remove(String identity) {
        synchronized (DataCache.class) {
            return mDataCacheMap.remove(identity);
        }
    }
}
