package com.iot.modbus_rtcp;

import org.junit.jupiter.api.Test;

/**
 * @author <a href="mailto:shilong.wang@alpha-ess.com">王仕龙</a>
 * 2024/11/25 14:51
 */
public class BinaryToDecimalTest {

    @Test
    public void binaryNegative() {
        int number = 225;
        String binaryString = Integer.toBinaryString(number);
        System.out.println("二进制表示: " + binaryString);
    }

    @Test
    public void binaryToNumber() {
        String binaryString = "11111011";
        int decimalNumber = Integer.parseInt(binaryString, 2);
        System.out.println("十进制表示: " + decimalNumber);
    }

    @Test
    public void hexStringToNegativeNumber() {
        String hexNumber = "F6";
        int a = Integer.parseInt(hexNumber, 16);
        // 取反(~)运算
        int resultNotA = ~a; // 结果为 1111 1010，即
        System.out.println("取反(~)运算结果：" + resultNotA + ", 反码：" + Integer.toBinaryString(resultNotA));

        // 计算反码和补码
        int complement = resultNotA + 1; // 计算补码
        System.out.println("负数的补码表示：" + complement + ", 补码：" + Integer.toBinaryString(resultNotA));
    }

    @Test
    public void hexStringToNegativeNumber1() {
//        String hexNumber = "F7"; // 16进制负数表示，等同于-9
//        String hexNumber = "F6"; // 16进制负数表示，等同于-10
        String hexNumber = "E6"; // 16进制负数表示，等同于-26
        int decimalNumber = Integer.parseInt(hexNumber, 16);

        String binaryNumber = Integer.toBinaryString(decimalNumber);
        System.out.println("有符号16进制数 " + hexNumber + " 对应的2进制数为 " + binaryNumber);

        binaryNumber = binOriginalToBack(binaryNumber);
        System.out.println("有符号16进制数 " + hexNumber + " 对应的反码为 " + binaryNumber + " 值为 " + Integer.parseInt(binaryNumber, 2));

        binaryNumber = binBackToRepair(binaryNumber, "1");
        System.out.println("有符号16进制数 " + hexNumber + " 对应反码的补码为 " + binaryNumber + " 值为 " + Integer.parseInt(binaryNumber, 2));

        System.out.println("有符号16进制数 " + hexNumber + " 对应的10进制数为 " + this.binRepairToDec(binaryNumber));
    }

    /**
     * 原码转反码
     *
     * @param number
     * @return
     */
    public static String binOriginalToBack(String number) {
        if (number.startsWith("0")) {
            return number;
        } else {
            StringBuffer sbf = new StringBuffer();
            sbf.append("1");
            String f_str = number.substring(1);
            for (int i = 0; i < f_str.length(); i++) {
                String s_str = String.valueOf(f_str.charAt(i));
                if (s_str.equals("0")) {
                    sbf.append("1");
                } else if (s_str.equals("1")) {
                    sbf.append("0");
                }
            }
            return sbf.toString();
        }

    }

    /**
     * 反码转补码
     *
     * @param
     * @return
     */
    public static String binBackToRepair(String a, String b) {
        if (a.startsWith("0")) {
            return a;
        }
        StringBuilder sb = new StringBuilder();
        int x = 0;
        int y = 0;
        int pre = 0;//进位
        int sum = 0;//存储进位和另两个位的和
        while (a.length() != b.length()) {//将两个二进制的数位数补齐,在短的前面添0
            if (a.length() > b.length()) {
                b = "0" + b;
            } else {
                a = "0" + a;
            }
        }
        for (int i = a.length() - 1; i >= 0; i--) {
            x = a.charAt(i) - '0';
            y = b.charAt(i) - '0';
            sum = x + y + pre;//从低位做加法
            if (sum >= 2) {
                pre = 1;//进位
                sb.append(sum - 2);
            } else {
                pre = 0;
                sb.append(sum);
            }
        }
        if (pre == 1) {
            sb.append("1");
        }
        // 翻转返回
        return sb.reverse().toString();
    }

    /**
     * 补码转十进制
     *
     * @param
     * @return
     */

    public String binRepairToDec(String str) {
        String h_number = str.substring(1);
        if (str.startsWith("0")) {
            return "" + Long.valueOf(h_number, 2);
        } else if (str.startsWith("1")) {
            return "-" + Long.valueOf(h_number, 2);
        }
        return null;
    }

}
